package io.kotless.terraform.functions

import java.io.File

//Escaping required for Windows
private fun escape(value: String) = value.replace("\\", "\\\\")

/** Get a canonical path of file */
fun path(file: File): String = escape(file.canonicalPath)

fun md5(field: String) = "md5($field)"
fun base64sha256(field: String) = "base64sha256($field)"

fun filemd5(file: File) = filemd5(path(file))
fun filemd5(file: String) = "filemd5(\"${file}\")"

fun file(file: File) = file(path(file))
fun file(file: String) = "file(\"$file\")"


fun timestamp() = "timestamp()"

fun link(field: String) = "\${$field}"
fun link(vararg parts: String?) = link(parts.filterNotNull().joinToString(separator = "."))

fun eval(func: String) = "\${$func}"
